#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count;
};

Input input_data(istream& in, bool prompt) {
    Input inp;
    size_t number_count;
    if (prompt){
        cerr << "Enter number count: ";
    }
    cin >> number_count;
    inp.numbers.resize(number_count);
    if (prompt){
                cerr << "Enter numbers: ";
        }
    for (size_t i = 0; i < number_count; i++) {
        cin >> inp.numbers[i];
    }

    if (prompt) {
            cerr << "Enter bin count: ";
    }
    cin >> inp.bin_count;
    return inp;
}

int main(int argc, char* argv[]) {
    curl_global_init(CURL_GLOBAL_ALL);
    if (argc > 1) {
        for (size_t i = 0; i < argc; i++) {
            cerr << "argv [" << i << "] = " << argv[i];
        }
    }
    auto in = input_data(cin, true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
